//Solution by lukasP (Lukáš Poláček)
#include <iostream>
#include <vector>
#include <bitset>
#include <string>
#include <algorithm>
#include <cstdio>
#include <bitset>
using namespace std;

#define rep(i,a,b) for(__typeof(b) i=a; i<(b); ++i)
const int MAXN = 300;

int main()
{
    int t;
    scanf("%d", &t);
    for (int cas = 0; cas < t; cas++)
    {
        int n;
        scanf("%d", &n);
        bitset<MAXN> target[MAXN];
        rep(i,0,n)
        {
            string s; cin >> s;
            reverse(s.begin(), s.end());
            target[i] = bitset<MAXN>(s);
        }

        vector<pair<int, int> > edges;
        vector<bool> first(n, false), seen(n, false);
        rep(i,0,n) if (!seen[i])
        {
            first[i] = true;
            seen[i] = true;
            int last = i;
            // find all junctions in the same strongly connected component as i
            // put them on a cycle
            rep(j,0,n) if (!seen[j] && target[i][j] && target[j][i])
            {
                seen[j] = true;
                edges.push_back({last, j});
                last = j;
            }
            if (last != i)
                edges.push_back({last, i});
        }

        rep(i,0,n) if (first[i])
            rep(j,0,n) if (first[j] && target[i][j] && i != j)
            {
                // put an edge between two strongly connected components if necessary
                bool ok = true;
                rep(k,0,n) if (first[k] && k != j && k != i)
                    if (target[i][k] && target[k][j])
                        ok = false;
                if (ok)
                    edges.push_back({i, j});
            }

        cout << edges.size() << endl;
        rep(i,0,edges.size())
            cout << edges[i].first + 1 << " " << edges[i].second + 1 << endl;
        cout << endl;
    }
}
